<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>
        <v-card>
            <v-card-title primary-title>
                <v-layout column>
                    <v-form
                            ref="form"
                            lazy-validation
                            id="login_form"
                            method="POST"
                            @submit.prevent="reset"
                    >
                        <v-text-field
                                :value="password"
                                :type="showPassword ? 'text' : 'password'"
                                :append-icon="showPassword ? 'visibility' : 'visibility_off'"
                                label="Password"
                                required
                                data-vv-name="password"
                                name="password"
                                @input="setPassword"
                                text-align="right"
                                @click:append="togglePassword"
                        ></v-text-field>



                        <v-layout row align-center justify-center>

                            <v-btn
                                    fill-width
                                    color="success"
                                    type="submit"
                            >
                                <v-progress-circular v-show="this.pending === true" indeterminate
                                                     color="white"></v-progress-circular>
                                <div v-show="this.pending === false">{{'ثبت رمز جدید'}}</div>
                            </v-btn>
                        </v-layout>
                    </v-form>
                </v-layout>
            </v-card-title>
        </v-card>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";
    export default {
        name: "resetPassword",
        data() {
            return {
                key: '',
            }
        },
        methods: {
            ...mapMutations({
                setUsername: 'resetPassword/setUsername',
                setPassword: 'resetPassword/setPassword',
                togglePassword: 'resetPassword/togglePassword',
                loginMode: 'resetPassword/loginMode',
                signUpMode: 'resetPassword/signUpMode',
                toggleMode: 'resetPassword/toggleMode'
            }),
            ...mapActions({
                resetPassword: 'resetPassword/resetPassword',
            }),
            reset(){
                this.setUsername(this.key);
                this.resetPassword();
            }
        },
        computed: {
            ...mapState({
                isLoggedIn: state => state.resetPassword.isLoggedIn,
                pending: state => state.resetPassword.pending,
                showPassword: state => state.resetPassword.showPassword,
                password: state => state.resetPassword.password,
                username: state => state.resetPassword.username,
                mode: state => state.resetPassword.mode,
                errorMessage: state => state.resetPassword.errorMessage,

            })
        },

        beforeRouteEnter(to, from, next) {
            if(Object.keys(to.query).length !== 0) { //if the url has query (?query)
                console.log(to.query.key);
                next(vm => {
                    vm.key = to.query.key
                })
            }
            next()
        }
    }
</script>
<style scoped>
</style>
